
#include "stdafx.h"
#include <ctype.h>
#include <vector>
#include <iostream>
#include "matching3D.h"

using namespace std;

/*donne l'ancien vector avec touts les points identifi, et donne les nouveau points avec leur identifiants (a voir cmt)*/

float matchRec(vector<CvPoint3D32f> pointpetit,vector<CvPoint3D32f> pointgrand , int *Match){//retourne le min des matching et le tableau de matching
	//Match est un tableau de int de la taille de pointpetit
	int n=(int)(pointpetit.size());
	int m=(int)(pointgrand.size());

	float aux;

	if (n==0){//si la liste est vide, plus de matching
		return 0.;
	}
	float min=FLT_MAX;
	float mincour;
	vector<CvPoint3D32f> vectpetit(pointpetit);
	//retire le dernier de la liste
	CvPoint3D32f P=vectpetit.back();
	vectpetit.pop_back();
	
	int * match=(int *)malloc((n-1)*sizeof(int));
	int k=0;
	for (vector<CvPoint3D32f>::iterator it=pointgrand.begin() ; it!=pointgrand.end() ; k++ ){
		//retire l'element, test , et remet l'element
		vector<CvPoint3D32f> vectcour(pointgrand);
		CvPoint3D32f cour = *it;
		it++;
		vectcour.erase((vectcour.begin()+k));
		aux=sqrt(pow((float) P.x - cour.x ,2) + pow((float) P.y - cour.y ,2) + pow((float) P.z - cour.z ,2));
		if(aux<=min)
		{
			mincour = aux + matchRec(vectpetit,vectcour,match);
			if (mincour < min ){
				min=mincour;
				memcpy(Match,match,(n-1)*sizeof(int));//on recopie les n-1 cases, 
				//on les decales pour prendre en compte la cese qui a t enlev
				for (int j=0; j<n-1;j++){
					if (Match[j]>=k)
						Match[j]++;
				}
				Match[n-1]=k;
			}
		}
		vectcour.clear();

	}
	free(match);
	return min;
		
}
void afficherT(int* tab,int k){
	cout<<"***"<<endl;
	if (k==0){
		cout<<"tableau vide"<<endl;
	}else{
		for (int i=0 ; i<k ;i++){
			printf("%d\t",tab[i]);
		}
		printf("\n\n");
	}
}
 void afficher(const std::vector<CvPoint3D32f> &VecteurAafficher)
 {
 	cout << "***" << std::endl;
 	if(!VecteurAafficher.empty())
 	{
 		std::vector<CvPoint3D32f>::const_iterator Iterateurvecteur;	// Construction d'un itrateur pour parcourir les lments du vecteur
 		for(Iterateurvecteur=VecteurAafficher.begin();Iterateurvecteur!=VecteurAafficher.end();Iterateurvecteur++)
 		{
 			std::cout << "Valeur de l'iterateur : " << (*Iterateurvecteur).x<<" "<< (*Iterateurvecteur).y <<" "<< (*Iterateurvecteur).z << std::endl;					// L'itrateur est un pointeur sur un lment du vecteur. Pour avoir son contenu il faut donc mettre la petite toile devant.
 		}

 	}
 	else
 	{
 		std::cout << "le vecteur est vide" << std::endl;
 	}
 	std::cout << "***" << std::endl;
 }

void matching(vector<CvPoint3D32f>*  pointID,vector<CvPoint3D32f> pointClient){
	//essai exaustif
	int n=(int)(pointClient.size());
	int m=(int)(pointID->size());
	int mn=min(n,m);
	int *Match=(int *)malloc(mn*sizeof(int));
	float min;
	if ( n<=m ){//plus de balles que de point repere
		min = matchRec(pointClient,*pointID,Match);
		for (int i=0;i<n;i++){
			(*pointID)[Match[i]]=pointClient[i];
		}	
	}else{//plus de point que de balle
		min = matchRec(*pointID,pointClient,Match);
		for (int i=0;i<m;i++){
			(*pointID)[i]=pointClient[Match[i]];
		}
	}
	free(Match);
}